package ru.zvzd3d.EKG.NikyEkgSD1;

import java.nio.ByteBuffer;   
import java.text.SimpleDateFormat;
import java.util.Date;

import android.os.Handler;
import android.os.Message;

public class OYogaDrumsRcv 
{
  // **** ,     
  
  private Handler m_handler = null;        //      
  private ONikyGraph m_Graph = null;       //    
  
  public void Init(Handler handler, ONikyGraph Graph)
  {
	  m_handler = handler;
	  m_Graph = Graph;
	  m_BufRcvSz = 0;
  };
	
  private byte [] m_Buf = new byte[512 + 3];     // TDataReciveBlock 
  	
  private byte [] m_BufRcv = new byte[512 + 3];  // TDataReciveBlock 
  private int m_BufRcvSz = 0;
  
  //public byte [] m_Info = new byte[44 + 3];  // TDataReciveBlock  
  
  public int m_SkipN = 0;
  
  //   TDataReciveBlock *******
  
  public long FileStartAdr = 0;     //    
  public long OldFile_StartAdr = 0; //     ( EmptyPos)  
  public long SysTime = 0;          //     
  
  public int TH_Config;         //    DS1621
  public int TH_Temperature;
  public int TH_TemperatureLo;
  public int TH_Counter;
  public int TH_Slope;
  public int TH_I2C_Error;
  
  public int ACP_CH2;           //  

  public long FM_T0;  //   24.06.2009
  public long FM_S;   //     CCP1  
  public int FM_N;   // (    CCP1)
  ;
  public int XOut;    //  28.06.2010
  public int YOut;    //   
  public int ZOut;
  public int MMA7455LT_I2CError;
  public int XYZN;
  
  public int MMC_Init_Status;   //   SD-
  public int MMCWriteCmdResp;   //     
  public int MMCWriteRespToken; //  SD-   
  
  public int m_NNN = 0;
  
  public String GetStartDate()
  {
    Date date = new Date();
    long StartTime = date.getTime() - (long) (SysTime/2.5e6*256 * 1000);
    date.setTime(StartTime);
    final SimpleDateFormat df = new SimpleDateFormat("dd.MM.yyyy, HH:mm:ss");
    return df.format(date);
  };
  

  private static int ToByte(final byte b)
  {
	 int i = b;
	 if (i<0) return i+256; else return i;
  };
  private static long ToDWORD(final byte buf[], int Ofs)
  {
	int a = buf[Ofs];     if (a<0) a += 256;
	int b = buf[Ofs+1];   if (b<0) b += 256;
	int c = buf[Ofs+2];   if (c<0) c += 256;
	long d = buf[Ofs+3];  if (d<0) d += 256;
	return a | (b<<8) | (c<<16) | (d<<24);
  };
  private static int ToWORD(final byte buf[], int Ofs)
  {
	int a = buf[Ofs];     if (a<0) a += 256;
	int b = buf[Ofs+1];   if (b<0) b += 256;
	return a | (b<<8);
  };
  
  public void ProcessDataRcvYogaDrums(ByteBuffer buffer, final int AddBufSz)
  {
	buffer.position(0);
	//byte buf[] = buffer.array();
	for (int i=0; i<AddBufSz; i++)
	{
	  m_BufRcv[m_BufRcvSz] = buffer.get(); // buf[i];
	  
	  if (m_BufRcvSz == 0 && m_BufRcv[m_BufRcvSz] != (byte)0xaa)
	  {
		m_BufRcvSz = 0; m_SkipN++; continue; 
	  };
	  if (m_BufRcvSz == 1 && m_BufRcv[m_BufRcvSz] != (byte)0x55)
	  {
		m_BufRcvSz = 0; m_SkipN++; continue; 
	  };
	  if (m_BufRcvSz == 2 && m_BufRcv[m_BufRcvSz] != (byte)0x39)
	  {
		m_BufRcvSz = 0; m_SkipN++; continue; 
	  };
	  if (m_BufRcvSz == 3 && m_BufRcv[m_BufRcvSz] != (byte)0xa7)
	  {
		m_BufRcvSz = 0; m_SkipN++; continue; 
	  };
	  m_BufRcvSz++;
	  if (m_BufRcvSz >= m_BufRcv.length)
	  {
		m_NNN++;
		CopyBlock();
		m_BufRcvSz = 0;
	  };
	};
  };
  
  /*struct TDataBlock
  {
      0: DWORD PSP;
      
      4: DWORD FileStartAdr;     //    
      8: DWORD OldFile_StartAdr; //     ( EmptyPos)
      
      12: DWORD SysTime;          //     
      
      16: BYTE TH_Config;         //    DS1621
      17: signed char TH_Temperature;
      18: BYTE TH_TemperatureLo;
      19: BYTE TH_Counter;
      20: BYTE TH_Slope;
      21: BYTE TH_I2C_Error;
      
      22: WORD ACP_CH2;           //  


      24: DWORD FM_T0;  //   24.06.2009
      28: DWORD FM_S;   //     CCP1  
      32: DWORD FM_N;   // (    CCP1)
      ;
      36: WORD XOut;    //  28.06.2010
      38: WORD YOut;    //   
      40: WORD ZOut;
      42: BYTE MMA7455LT_I2CError;
      43: BYTE XYZN;
      ;
      //  - 
      44: WORD Data[(512-16-6-2-12 - 8)/2];
      
      // 
      512: BYTE MMC_Init_Status;   //   SD-
      513: BYTE MMCWriteCmdResp;   //     
      514: BYTE MMCWriteRespToken; //  SD-   
  };
 */
  
  private void CopyBlock()
  {
	 byte[] tmp = m_BufRcv;
	 m_BufRcv = m_Buf; 
	 m_Buf = tmp;
	 
	 m_handler.sendEmptyMessage(777);
  };
	
  
  public void ProcessBlock()
  {
	 int DataPos = m_Graph.m_DataPos;
	 for (int i=0; i<234; i++)
	 {
		int vLo = m_Buf[44+i+i] & 0xff;
		int vHi = m_Buf[44+i+i+1] & 0xff;
		 int Value = vLo | (vHi<<8);
		m_Graph.m_Data[DataPos] = Value;
		DataPos++; 
		if (DataPos >= m_Graph.m_MaxLen) DataPos = 0;		
	 };
	 m_Graph.m_DataPos = DataPos;
	 
	 FileStartAdr = ToDWORD(m_Buf, 4);
	 OldFile_StartAdr = ToDWORD(m_Buf, 8);
	 SysTime      = ToDWORD(m_Buf, 12);
	 
	 TH_Config = ToByte(m_Buf[16]);
	 TH_Temperature = m_Buf[17];
	 TH_TemperatureLo = ToByte(m_Buf[18]);
	 TH_Counter =   ToByte(m_Buf[19]);
	 TH_Slope =     ToByte(m_Buf[20]);
	 TH_I2C_Error = ToByte(m_Buf[21]);
	  
	 ACP_CH2 = ToWORD(m_Buf, 22);

	 FM_T0 = ToDWORD(m_Buf, 24);
	 FM_S  = ToDWORD(m_Buf, 28);   
	 FM_N = (int)ToDWORD(m_Buf, 32);
	  ;
	 XOut = ToWORD(m_Buf, 36);
	 YOut = ToWORD(m_Buf, 38); 
	 ZOut = ToWORD(m_Buf, 40);
	 MMA7455LT_I2CError = ToByte(m_Buf[42]);
	 XYZN = ToByte(m_Buf[43]);
	 
	 MMC_Init_Status = ToByte(m_Buf[512]);
	 MMCWriteCmdResp = ToByte(m_Buf[513]);
	 MMCWriteRespToken = ToByte(m_Buf[514]);
  };
  
  
  
};
